<?php
/************************************************************
Program		Slashorg Downloader
Filename	index.php
Version		0.96
Last update	26/01/2006

Send bug reports to dev@slashorg.net
************************************************************/

if (!file_exists('conf.php')) {
	Header ('Location: setup/');
	exit();
}

$start_time = microtime();
require_once ('conf.php');
require_once ('include/inc_functions.php');

require_once ('include/inc_mysql.php');

// Load iconv support if extension is present.
if (in_array('iconv', get_loaded_extensions())) {
	iconv_set_encoding('output_encoding', $conf_charset);
	ob_start('ob_iconv_handler');
}

// Definitions
$p = $hash_key = $act = $html = $warning = $redirect = NULL;
$access_ok = false;

session_start();

// GET parameters
if (isset($_GET['p']))
	$p = $_GET['p'];
if (isset($_GET['key']))
	$hash_key = addslashes($_GET['key']);
if (isset($_GET['act']))
	$act = $_GET['act'];
if (isset($_GET['sort_by']))
        $default_order['type'] = $_GET['sort_by'];
if (isset($_GET['sort_dir']))
        $default_order['value'] = $_GET['sort_dir'];


// Language support
// The 'preg_match' is a security feature.
if (isset($_SESSION['user_lang']) && !preg_match('/\.\./', $_SESSION['user_lang'])) {
	require_once ("lang/{$_SESSION['user_lang']}.php");
} else {
	$_SESSION['user_lang'] = $SetDisplayLang;
	require_once ("lang/$SetDisplayLang.php");
}

// We don't allow links containing '..' for security reasons.
if (preg_match('/\.\./', $p))
	$p = NULL;

// MySQL database connection
$db = new MySQL($db_access['host'], $db_access['database'], $db_access['username'], $db_access['password']);

// Remove stale links
$current_time = time();
$q0 = $db->query("DELETE FROM cgd_access WHERE end_date < '$current_time'");

switch ($act) {
case 'hash_gen':
case 'hash_gen_do':
	$html = $lang['access_denied'];
	$which_include = 'include/inc_text_zone.php';
	if (isset($_SESSION['session_key'])) {
		$hash_key = $_SESSION['session_key'];
		$q0 = $db->query('SELECT dir, is_admin FROM cgd_access WHERE hash = \'' . addslashes($hash_key) . '\'');
		if ($db->num_rows($q0) == 1) {
			$var = $db->assoc($q0);
			if ($var['is_admin']) {
				$ip_checked = $admin_checked = $new_checked = $allow_delete = NULL;
				$p = check_root_dir($var['dir'], $p);
				$action = '?act=hash_gen_do&amp;p=' . urlencode($p);
				if ($act == 'hash_gen') {
					$days = $mins = $hours = 0;
					$access_limit = 1;
					$which_include = 'include/inc_new_share_form.php';
				} else {
					$days = (int)$_POST['days'];
					$hours = (int)$_POST['hours'];
					$mins = (int)$_POST['mins'];
					$access_limit = (int)$_POST['access_limit'];
					$ip_limit = '0.0.0.0';
					$is_admin = $new_account = 0;

					if(isset($_POST['ip_limit']))
						$ip_limit = NULL;
					if (isset($_POST['is_admin']))
						$is_admin = 1;
					if (isset($_POST['new_account']))
						$new_account = 1;

					if (($days || $hours || $mins) && ($access_limit || $new_account)) {
						$current_time = time();
						$end_date = 60 * $mins + 3600 * $hours + 86400 * $days + $current_time;
						$hash = md5(microtime() + $start_time);
						$q0 = $db->query("INSERT INTO cgd_access VALUES ('', '$current_time', '$end_date', '$access_limit', '$hash', '" . addslashes($p) . "', '$ip_limit', '$is_admin', '$new_account', null)");

						$url = 'http://' . $_SERVER['HTTP_HOST'];
						if (dirname($_SERVER['PHP_SELF']) != '/')
							$url .= dirname($_SERVER['PHP_SELF']);
						$url .= "/?key=$hash";
						
						$html = $lang['hash_key_success']."<a href=\"$url\">$url</a>";

					} else {
						$warning = $lang['empty_fields'];
						$which_include = 'include/inc_new_share_form.php';
					}
				}
			}
		}
	}
	require_once ('include/inc_header.php');
	require_once ('include/inc_javascript_popup.php');
	$nav = '<p>'.$lang['location'].' '.display_nav($p, $UploadDir)." > Administration</p><br />\n";
	echo ($nav);
	require_once ($which_include);
	require_once ('include/inc_footer.php');
	exit();
	break;

case 'upload_do':
	$hash_key = $_GET['session_key'];
case 'upload':
	if (!isset($session_id) && isset($_SESSION['session_key']))
		$hash_key = $_SESSION['session_key'];

	$html = $lang['access_denied'];
	$which_include = 'include/inc_text_zone.php';
	if (isset($hash_key)) {
		$q0 = $db->query('SELECT dir, is_admin FROM cgd_access WHERE hash = \'' . addslashes($hash_key) . '\'');
		if ($db->num_rows($q0) == 1) {
			$var = $db->assoc($q0);
			if ($var['is_admin']) {
				$p = check_root_dir($var['dir'], $p);

				if ($act == 'upload') {
					$MaxFileUploadSize = str_replace('M', '', min(ini_get('post_max_size'), ini_get('upload_max_filesize')));
					$which_include = 'include/inc_upload_form_java.php';
				} else {
					// The Java applet doesn't seem to like UTF-8 encoding
					if (in_array('iconv', get_loaded_extensions())) {
						iconv_set_encoding('output_encoding', 'ISO-8859-1');
					}

					foreach($_FILES as $tagname => $object) {
						umask(0);
						
						$filepath = $UploadDir . $p . $object['name'];

						if (file_exists($filepath)) {
							if (isset($upload_same_name))
								$upload_same_name .= ', ' . $object['name'];
							else
								$upload_same_name = $object['name'];
						} else {
							if (@move_uploaded_file($object['tmp_name'], $filepath)) {
								chmod($filepath, $SetChmod);
							} else {
								if (isset($upload_error))
									$upload_error .= ', ' . $object['name'];
								else
									$upload_error = $object['name'];
							}
						}
					}
					
					if (isset($upload_same_name))
						echo ("{$lang['upload_same_name']}<br><br>$upload_same_name");

					if (isset($upload_error))
						echo ("{$lang['upload_error']}<br><br>$upload_error");

					if (!isset($upload_same_name) && !isset($upload_error))
						echo ($lang['upload_success']);
					exit();
				}	
			}
		}
	}
	require_once ('include/inc_header.php');
	$nav = '<p>'.$lang['location'].' '.display_nav($p, $UploadDir)." > Upload</p><br />\n";
	echo ($nav);
	require_once ($which_include);
	require_once ('include/inc_footer.php');
	exit();
	break;

case 'new_folder':
	$html = $lang['access_denied'];
	$which_include = 'include/inc_text_zone.php';
	if (isset($_SESSION['session_key'])) {
		$hash_key = $_SESSION['session_key'];
		// Make sure user is admin.
		$q0 = $db->query('SELECT dir, is_admin FROM cgd_access WHERE hash = \'' . addslashes($hash_key) . '\'');
		if ($db->num_rows($q0) == 1) {
			$var = $db->assoc($q0);
			if ($var['is_admin']) {
				$p = check_root_dir($var['dir'], $p);

				if(isset($_POST['folder_name'])) {
					// For Windows compatibility we don't allow some characters.
					if (preg_match('/\\\|\/|:|\*|\?|"|<|>|\|/', $_POST['folder_name']) == 1)
						$warning = $lang['folder_illegal_chars'];

					if ($_POST['folder_name'] == '')
						$warning = $lang['folder_name_empty'];
					
					if (!isset($warning)) {
						umask(0);
						//$folder_name = iconv($conf_charset, 'ISO-8859-15', urldecode($UploadDir.$p.$_POST['folder_name']));
						//$folder_name = urldecode($UploadDir.$p.$_POST['folder_name']);
						if (in_array('iconv', get_loaded_extensions())) {
							$folder_name = urldecode($UploadDir.$p.iconv($conf_charset, 'ISO-8859-1', $_POST['folder_name']));
						} else {
							$folder_name = urldecode($UploadDir.$p.$_POST['folder_name']);
						}
						if(@mkdir($folder_name, $SetChmod))
							$html = $lang['folder_created'].'<br /><br />[<a href="?p='.urlencode($p).'">'.$lang['continue'].'</a>]';
						else
							$warning = $lang['folder_error'];
					}
				}

				if (isset($warning) || !isset($_POST['folder_name'])) {
					$folder_name = NULL;
					if (isset($_POST['folder_name']))
						$folder_name = $_POST['folder_name'];
					$which_include = 'include/inc_new_folder.php';
				}
			}
		}
	}
	require_once ('include/inc_header.php');
	$nav = '<p>'.$lang['location'].' '.display_nav($p, $UploadDir).' > '.$lang['new_folder']."</p><br />\n";
	echo ($nav);
	require_once ($which_include);
	require_once ('include/inc_footer.php');
	exit();
	break;

case 'delete_do':
case 'delete':
	$html = $lang['access_denied'];
	if (isset($_SESSION['session_key'])) {
		$hash_key = $_SESSION['session_key'];
		$q0 = $db->query('SELECT dir, is_admin FROM cgd_access WHERE hash = \'' . addslashes($hash_key) . '\'');
		if ($db->num_rows($q0) == 1) {
			$var = $db->assoc($q0);
			if ($var['is_admin']) {
				$p = check_root_dir($var['dir'], $p);

				if ($_GET['act'] == 'delete') {
					if (is_dir($UploadDir . $p))
						$html = $lang['confirm_delete_folder'].'<br /><br />[<a href="?act=delete_do&amp;p='.urlencode($p).'">'.$lang['continue'].'</a>] [<a href="javascript:history.back()">'.$lang['cancel'].'</a>]';
					else
						$html = $lang['confirm_delete_file'].'<br /><br />[<a href="?act=delete_do&amp;p='.urlencode($p).'">'.$lang['continue'].'</a>] [<a href="javascript:history.back()">'.$lang['cancel'].'</a>]';					
				} else {
					if (($dir_name = dirname($p) . '/') == './')
						$dir_name = NULL;

					if(erase_stuff($UploadDir . $p)) {
						$redirect = '?p=' . urlencode($dir_name);
						$html = $lang['delete_ok'].'<br /><br />'.$lang['redirect'];
					} else {
						$html = $lang['delete_error'].'<br /><br />[<a href="?p='.$dir_name.'">'.$lang['continue'].'</a>]';
					}
				}
			}
		}
	}
	require_once ('include/inc_header.php');
	$nav = '<p>'.$lang['location'].' '.display_nav($p, $UploadDir).' > '.$lang['delete']."</p><br />\n";
	echo ($nav);
	require_once ('include/inc_text_zone.php');
	require_once ('include/inc_footer.php');
	exit();
	break;

case 'login':
	if (isset($_POST['name'])) {
		$warning = $lang['login_failed'];
		$name = addslashes($_POST['name']);
		$pw = addslashes(md5($_POST['pw']));
		$q0 = $db->query("SELECT dir, is_admin FROM cgd_users WHERE name = '$name' AND passwd = '$pw'");
		if ($db->num_rows($q0) == 1) {
			$warning = FALSE;
			$var = $db->assoc($q0);
			$current_time = time();
			$end_date = 86400 + $current_time; // La clef expire aprs une journe
			$hash = md5(microtime() + $start_time);
			$p = addslashes($var['dir']);
			$is_admin = $var['is_admin'];
			$q0 = $db->query("INSERT INTO cgd_access VALUES ('', '$current_time', '$end_date', '-1', '$hash', '$p', '0.0.0.0', '$is_admin', '0', '$name')");
			$_SESSION['session_key'] = $hash;
		}
	}
	
	if (!$warning && isset($_POST['name'])) {
	    $redirect = './';
	}
	
	require_once ('include/inc_header.php');
	$nav = '<p>'.$lang['location'].' '.display_nav('', $UploadDir)." > Login</p><br />\n";
	echo ($nav);
	if ($warning || !isset($_POST['name'])) {
		require_once ('include/inc_login_form.php');
	} else {
		$html = $lang['login_successful'];
		require_once ('include/inc_text_zone.php');
	}
	require_once ('include/inc_footer.php');
	exit();
	break;

case 'prefs':
	if (isset($_POST['lang'])) {
		$which_include = 'include/inc_text_zone.php';
		$redirect = "./";
		$html = $lang['prefs_changed'].'<br /><br />'.$lang['redirect'];
		$_SESSION['user_lang'] = $_POST['lang'];

		if (isset($_POST['email'])) {
			$sql = "SELECT user_account FROM cgd_access WHERE hash = '".addslashes($_SESSION['session_key'])."'";
			$q0 = $db->query($sql);
			$var = $db->assoc($q0);
			$sql = '';
			if ($_POST['email']) {
				$sql = "UPDATE cgd_users SET email = '".addslashes($_POST['email'])."'";
			}
			if ($_POST['pw1'] && $_POST['pw1'] == $_POST['pw2']) {
				if ($sql) {
					$sql .= ", passwd = '".md5($_POST['pw1'])."'";
				} else {
					$sql .= "UPDATE cgd_users SET passwd = '".md5($_POST['pw1'])."'";
				}
			}

			if ($sql) {
				$sql .= " WHERE name = '{$var['user_account']}'";
				$q0 = $db->query($sql);
			}
		}
	} else {
		$which_include = 'include/inc_prefs_form.php';
		$html = $lang['choose_lang']."<br/><br />\n";
		// Get file & folder names
		if ($dh = opendir('lang/')) {
			while (($file = readdir($dh)) !== false) {
				if ($file != '.' && $file != '..' && $file != '_flags') {
					$file = substr($file, 0, -4); // Remove php extension
					$html .= '<input name="lang" value="'.$file.'" ';
					if ($file == $_SESSION['user_lang'])
						$html .= 'checked="checked"';
					$html .= 'type="radio" /> <img src="lang/_flags/'.$file.'.gif" alt="'.$file.'" />'.$file."<br /><br />\n";
				}
			}
		}

		// Get current email
		if ($_SESSION['session_key']) {
			$sql = "SELECT user_account, email FROM cgd_access, cgd_users WHERE hash = '".addslashes($_SESSION['session_key'])."'";
			$q0 = $db->query($sql);
			$var = $db->assoc($q0);

			// Let's make sure someone's not playing with their session data...
			if ($var['user_account']) {
				// Build form...
				$html .= "<br />\n";
				$html .= '<p>'.$lang['email_address'].'<input name="email" type="text" value="'.$var['email'].'" size="32" maxlength="80" /></p>'."\n";
				$html .= '<p>'.$lang['password'].'<input name="pw1" type="password" size="32" maxlength="20" /></p>'."\n";
				$html .= '<p>'.$lang['repeat_password'].'<input name="pw2" type="password" size="32" maxlength="20" /></p>'."\n";

			}
		
		}
	}

	require_once ('include/inc_header.php');
	require_once ($which_include);
	require_once ('include/inc_footer.php');
	exit();
	break;

case 'help':
	require_once ('include/inc_help.php');
	exit();
	break;

default:
	break;
}

// Has the visitor entered a hash key?
if ($hash_key) {
	$q0 = $db->query("SELECT uses_left, dir, ip, is_admin, can_create_account FROM cgd_access WHERE hash = '$hash_key'");
	if ($db->num_rows($q0) == 1) {
		$var = $db->assoc($q0);
		$p = $var['dir'];
		if ($var['can_create_account']) {
			$html = $name = $email = NULL;
			$action = '?key='.$hash_key;
			if ($_POST) {
				$name = $_POST['name'];
				$email = $_POST['email'];
				$pw1 = $_POST['pw1'];
				$pw2 = $_POST['pw2'];
				if ($name && $email && $pw1 && $pw2) {
					if ($pw1 == $pw2) {
						$q0 = $db->query("SELECT id FROM cgd_users WHERE name = '" . addslashes($name) . "'");
						if (!$db->num_rows($q0)) {
							$pw1 = md5($pw1);
							$is_admin = $var['is_admin'];
							$q0 = $db->query("INSERT INTO cgd_users VALUES ('', '" . addslashes($name) . "', '$pw1', '" . addslashes($email) . "', '" . addslashes($p) . "', '$is_admin')");
							$q0 = $db->query("DELETE FROM cgd_access WHERE hash = '$hash_key'");
							$html = $lang['account_creation_successful'].'<br /><br />'.$lang['link_to_login'];
						} else { // Duplicated account name
							$warning = $lang['duplicated_account'];
						}
					} else {
						$warning = $lang['different_pw'];
					}
				} else {
					$warning = $lang['empty_fields'];
				}
			}
			require_once ('include/inc_header.php');
			$nav = '<p>'.$lang['location'].' '.display_nav('', $UploadDir).' > '.$lang['new_account']."</p><br />\n";
			echo ($nav);
			if (!$html)
				require_once ('include/inc_new_account_form.php');
			else
				require_once ('include/inc_text_zone.php');
			require_once ('include/inc_footer.php');
			exit();
		} else {
			$uses_left = $var['uses_left'];
			$ip = $var['ip'];
			if ($uses_left == 0) {
				$warning = $lang['stale_key'];
			} else {
				if ($ip == '0.0.0.0') { // No IP restrictions
					$client_ip = '0.0.0.0';
				} else {
					$client_ip = $_SERVER['REMOTE_ADDR'];
					if ($client_ip != $ip && $ip)
						$warning = $lang['wrong_ip'];
				}
				if (!$warning) {
					if ($uses_left > 0)
						$uses_left--;
					$q0 = $db->query("UPDATE cgd_access SET uses_left = '$uses_left', ip = '$client_ip' WHERE hash = '$hash_key'");
					$_SESSION['session_key'] = $hash_key;
				}
			}
		}
	} else {
		$warning = $lang['invalid_key'];
	}
}

// Check the session
if (isset($_SESSION['session_key'])) {
	$hash_key = $_SESSION['session_key'];
	$q0 = $db->query("SELECT dir, is_admin FROM cgd_access WHERE hash = '$hash_key'");
	if ($db->num_rows($q0) == 1) {
		$var = $db->assoc($q0);
		//$id = $var['id'];
		$is_admin = $var['is_admin'];

		$p = check_root_dir($var['dir'], $p);

		$access_ok = 1;

	} else {
		$warning = $lang['stale_key'];
	}
}

if ($access_ok) {

	// Definitions related to listing files
	$theArray['file']['name'] = $theArray['file']['size'] = $theArray['file']['date'] = array ();
	$theArray['dir']['name'] = $theArray['dir']['date'] = array ();

	$unit_bytes = $lang['bytes'];
	$unit_bytes_short = $lang['bytes_short'];
	$units = array(" $unit_bytes", "k$unit_bytes_short", "M$unit_bytes_short", "G$unit_bytes_short", "T$unit_bytes_short");

	$nav = NULL;
	$nav .= '<p>'.$lang['location'].' '.display_nav($p, $UploadDir)."</p><br />\n";

	// Append sort preference to links
	$sort_link = 'sort_by='.$default_order['type'].'&amp;sort_dir='.$default_order['value'];

	if ($is_admin) {
		$nav .= '<p class="main">'.$lang['admin_menu'].' <a href="?act=hash_gen&amp;p='.urlencode($p).'" title="'.$lang['share_folder'].'">'.$lang['share'].'</a>, <a href="?act=upload&amp;p='.urlencode($p).'" title="'.$lang['upload_folder'].'">'.$lang['upload'].'</a>, <a href="?act=new_folder&amp;p='.urlencode($p).'" title="'.$lang['new_folder'].'">'.$lang['new_folder'].'</a>';
		if (!$var['dir']) // Super admin
			$nav .= ', <a href="admin.php" title="'.$lang['control_panel_info'].'">'.$lang['control_panel'].'</a>';
		$nav .= "</p><br />\n";
	}

	$dir = $UploadDir . $p;

	if (is_dir($dir)) {
		// Get file & folder names
		if ($dh = opendir($dir)) {
			while (($file = readdir($dh)) !== false) {
				if ($file != '.' && $file != '..') {

					// Add files and folders to array for further analyse & display
					if (is_file($UploadDir.$p.$file)) {
						array_push ($theArray['file']['name'], $file);
						array_push ($theArray['file']['size'], filesize($UploadDir.$p.$file));
						array_push ($theArray['file']['date'], filemtime($UploadDir.$p.$file));
					} else {
						array_push ($theArray['dir']['name'], $file.'/');
						array_push ($theArray['dir']['date'], filemtime($UploadDir.$p.$file));
					}
				}
			}
			closedir($dh);
		}

	// '$a' is for files, '$b' is for folders (which don't have an attribute 'size')
	switch ($default_order['type']) {

	case 'size':
		$a[1] = 'size';
		$a[2] = 'name';
		$a[3] = 'date';
		$b[1] = 'name';
		$b[2] = 'date';
		break;

	case 'name':
		$a[1] = 'name';
		$a[2] = 'size';
		$a[3] = 'date';
		$b[1] = 'name';
		$b[2] = 'date';
		break;

	case 'date':
		$a[1] = 'date';
		$a[2] = 'name';
		$a[3] = 'size';
		$b[1] = 'date';
		$b[2] = 'name';
		break;

	default:
		exit();
	}

	// Sort the array
	if ($default_order['value'] == 'asc') {
		array_multisort($theArray['file'][$a[1]], SORT_DESC, $theArray['file'][$a[2]], $theArray['file'][$a[3]]);
		array_multisort($theArray['dir'][$b[1]], SORT_DESC, $theArray['dir'][$b[2]]);
	} else {
		array_multisort($theArray['file'][$a[1]], SORT_ASC, $theArray['file'][$a[2]], $theArray['file'][$a[3]]);
		array_multisort($theArray['dir'][$b[1]], SORT_ASC, $theArray['dir'][$b[2]]);
	}

	// Get extra info
	$extra['file_count'] = count ($theArray['file']['name']);
	$extra['dir_count'] = count ($theArray['dir']['name']);
	$extra['size'] = array_sum ($theArray['file']['size']);

	// We display ...

	// ... the "parent folder" icon if there is one.
	if ($p) {
		$p_explode = explode('/', $p);
		$i = 0;
		$parent_dir = '';
			for($i ; $i < count($p_explode) - 2 ; $i++) {
			$parent_dir .= $p_explode[$i].'/';
		}
			$go_link = urlencode($parent_dir).'&amp;'.$sort_link;
		$html = '<a class="nb" href="?'.$go_link.'"><img alt="[PARENT FOLDER]" src="images/dir_icon_up.gif" /></a><a href="?p='.$go_link.'">'.$lang['parent_dir']."</a><br />\n";
	} else {
		// or a HomePage link if a homepage has been specified in the config file.
		if ($HomePage)
			$html = '<a class="nb" href="'.$HomePage.'"><img alt="[HOMEPAGE]" src="images/dir_icon_up.gif" /></a><a href="'.$HomePage.'">'.$lang['return_to_homepage']."</a><br />\n";
	}

	// ... then the various folders.
	while ($file = array_pop ($theArray['dir']['name'])) {

		// Folder modification date
		$modif_date = $lang['modification_date'].strftime("{$lang['date_format']} {$lang['at']} %H:%M:%S", array_pop ($theArray['dir']['date']));

		$go_link = urlencode($p.$file).'&amp;'.$sort_link;
		$html .= '<a class="nb" href="?p='.$go_link.'"><img alt="[DIR]" src="images/dir_icon.gif" /></a><a href="?p='.$go_link.'" title="'.$modif_date.'">'.htmlspecialchars($file, ENT_NOQUOTES).'</a>';

		if ($is_admin) {
			$html .= '<span class="pad">[<a href="?act=hash_gen&amp;p='.urlencode($p.$file).'">'.$lang['share_folder'].'</a>]</span>';
			$html .= '<span class="pad">[<a href="?act=delete&amp;p='.urlencode($p.$file).'" title="'.$lang['delete'].'">'.'X'.'</a>]</span>';
		}
		$html .= "<br />\n";

	}

	// ... and finally the files.
	while ($file = array_pop ($theArray['file']['name'])) {
		$filesize = array_pop ($theArray['file']['size']);

		// File modification date
		$modif_date = $lang['modification_date'].strftime("{$lang['date_format']} {$lang['at']} %H:%M:%S", array_pop ($theArray['file']['date']));
		$html .= '<a class="nb" href="?p='.urlencode($p.$file).'"><img alt="[DOWNLOAD]" src="images/dl_icon.gif" /></a>';
		$html .= '<a href="?p='.urlencode($p.$file).'" title="'.$modif_date.'">'.htmlspecialchars($file, ENT_NOQUOTES).'</a>';

		// Unit conversion code
		$i = 0;
		while ($filesize >= 1024) {
			$filesize /= 1024;
			$i++;
		}

		// Display file size
		$html .= '<span class="pad">['.round($filesize, 1).$units[$i].']</span>';

		if ($is_admin)
                	$html .= '<span class="pad">[<a href="?act=delete&amp;p='.urlencode($p.$file).'" title="'.$lang['delete'].'">'.'X'.'</a>]</span>';

		$html .= "<br />\n";
		}
	} else {
		if (is_file($dir)) {
		// Start file download
			send_file($dir, $ThrottleSpeed);
			exit();
		} else {
			// Broken link
			$html .= $lang['file_not_found'];
		}
	}

	// If there is no parent folder, no homepage link, no folders or files, then display an error message.
	if (!$html)
        	$html = $lang['empty_folder'];

}	

// Order stuff
$lang[$default_order['type']] = '<b>'.$lang[$default_order['type']].'</b>';
$lang[$default_order['value']] = '<b>'.$lang[$default_order['value']].'</b>';


$order =        $lang['order_by'].'<a href="?p='.$p.'&amp;sort_by=name&amp;sort_dir='.$default_order['value'].'">'.$lang['name'].'</a>, ';
$order .=       '<a href="?p='.$p.'&amp;sort_by=size&amp;sort_dir='.$default_order['value'].'">'.$lang['size'].'</a>, ';
$order .=       '<a href="?p='.$p.'&amp;sort_by=date&amp;sort_dir='.$default_order['value'].'">'.$lang['date'].'</a> -- ';
$order .=       $lang['order'].'<a href="?p='.$p.'&amp;sort_by='.$default_order['type'].'&amp;sort_dir=asc">'.$lang['asc'].'</a>, ';
$order .=       '<a href="?p='.$p.'&amp;sort_by='.$default_order['type'].'&amp;sort_dir=desc">'.$lang['desc'].'</a>';

$sort_block = '<p class="sub">'.$order.'</p>';

// Extra information
$i = 0;
while ($extra['size'] >= 1024) {
	$extra['size'] /= 1024;
	$i++;
}

$extra_info = '<p class="sub" style="border-bottom: 1px solid #004080;">'.$lang['folder_contains'].' '.$extra['file_count'].' '.$lang['files'].' ('.round($extra['size'], 1).$units[$i].') '.$lang['and'].' '.$extra['dir_count'].' '.$lang['folders'].'.</p>';


require_once ('include/inc_header.php');
if ($access_ok) {
	echo ($nav);
	require_once ('include/inc_text_zone.php');
} else {
	require_once ('include/inc_hash_form.php');
}
require_once ('include/inc_footer.php');
?>
